## com.saxonica.codegen
Class SingletonComparisonCompiler

    java.lang.Object
      com.saxonica.codegen.ExpressionCompiler
          com.saxonica.codegen.ToBooleanCompiler
              com.saxonica.codegen.SingletonComparisonCompiler

    public class SingletonComparisonCompiler

extends ToBooleanCompiler

Generate Java code to implement a value comparison operator

Constructor Summary
`SingletonComparisonCompiler()`

Method Summary
`protected static String` `compileComparison(AtomicComparer comparer, String op0var, CompilerService compiler, String op1var, int operator)`
`String` `compileToEffectiveBooleanValue(CompilerService compiler, Expression expr, ReturnAction result)` Generate Java code to evaluate the effective boolean value of the expression
`String` `compileToItem(CompilerService compiler, Expression exp)` Generate Java code to evaluate the expression as an Item

Methods inherited from class com.saxonica.codegen.ToBooleanCompiler
`compilePush, compileToCharSequence, compileToIterator`

Methods inherited from class com.saxonica.codegen.ExpressionCompiler
`compileAsLoop, compileToValueRepresentation, getConfiguration, makeExpressionCompiler, setConfiguration`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SingletonComparisonCompiler

    public SingletonComparisonCompiler()

Method Detail

### compileToItem

    public String compileToItem(CompilerService compiler,
                                Expression exp)

  Description copied from class: `ExpressionCompiler`
  Generate Java code to evaluate the expression as an Item

  Overrides:
    `compileToItem` in class `ToBooleanCompiler`
  Parameters:
    `compiler` - the compiler service
    `exp` - the expression to be compiled
  Returns:
    a simple Java expression (usually the name of a variable that has been declared) which will be of class `Item`, and which will hold the value of the expression at run-time (or hold null, representing an empty sequence).

### compileToEffectiveBooleanValue

    public String compileToEffectiveBooleanValue(CompilerService compiler,
                                                 Expression expr,
                                                 ReturnAction result)

  Description copied from class: `ExpressionCompiler`
  Generate Java code to evaluate the effective boolean value of the expression

  Specified by:
    `compileToEffectiveBooleanValue` in class `ToBooleanCompiler`
  Parameters:
    `compiler` - the compiler service
    `expr` - the XPath expression to be compiled
    `result` - indicates how the boolean result is to be returned
  Returns:
    the result depends on the supplied value of the options argument. If options is a JavaDeclaration, the code must declare a Java variable and return the name of this variable. If options is a JavaAssignment, the code must assign the value to an existing Java variable. If options is a Return, the code must generate a return statement that returns the value of the boolean (in which case the result of this method is null).

### compileComparison

    protected static String compileComparison(AtomicComparer comparer,
                                              String op0var,
                                              CompilerService compiler,
                                              String op1var,
                                              int operator)

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.